/**********************************************************************
** Copyright (C) 2002 Trolltech AS.  All rights reserved.
**
** This file is part of TQt Designer.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** Licensees holding valid TQt Enterprise Edition or TQt Professional Edition
** licenses may use this file in accordance with the TQt Commercial License
** Agreement provided with the Software.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
**   information about TQt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

#ifndef LISTDND_H
#define LISTDND_H

#include <tqobject.h>
#include <tqscrollview.h>

class ListDnd : public TQObject
{
    Q_OBJECT
  
public:
    enum DragMode { None = 0, External = 1, Internal = 2, Both = 3, Move = 4, NullDrop = 8 };
    ListDnd( TQScrollView * eventSource, const char * name = 0 );
    void setDragMode( int mode );
    int dragMode() const;
    bool eventFilter( TQObject *, TQEvent * event );

protected:
    virtual bool dragEnterEvent( TQDragEnterEvent * event );
    virtual bool dragLeaveEvent( TQDragLeaveEvent * );
    virtual bool dragMoveEvent( TQDragMoveEvent * event );
    virtual bool dropEvent( TQDropEvent * event );
    virtual bool mousePressEvent( TQMouseEvent * event );
    virtual bool mouseMoveEvent( TQMouseEvent * event );
    virtual void updateLine( const TQPoint & dragPos );
    virtual bool canDecode( TQDragEnterEvent * event );

    TQScrollView * src;
    TQWidget * line;
    TQPoint mousePressPos;
    TQPoint dragPos;
    bool dragInside;
    bool dragDelete;
    bool dropConfirmed;
    int dMode;
};

#endif // LISTDND_H
